//+------------------------------------------------------------------+
//|                                     ALVIBU_3MA_Gist&Stat_v01.mq4 |
//|                                                     ALVIBU       |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "ALVIBU"
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 1
#property indicator_buffers 3
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 Gold
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
//---- input parameters

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];

//---- 
extern int    BrasForAnalis   = 500;
extern int    ExtPeriodFastMA = 6;
extern int    ExtPeriodNormMA = 24;
extern int    ExtPeriodSlowMA = 96;
extern int    ExtModeFastMA   = 1; // 0 = SMA, 1 = EMA, 2 = SMMA, 3 = LWMA
extern int    ExtModeNormMA   = 1; // 0 = SMA, 1 = EMA, 2 = SMMA, 3 = LWMA
extern int    ExtModeSlowMA   = 1; // 0 = SMA, 1 = EMA, 2 = SMMA, 3 = LWMA
extern int    ExtPriceFastMA  = 5; // 0 = Close, 1 = Open, 2 = High, 3 = Low, 4 = HL/2, 5 = HLC/3, 6 = HLCC/4
extern int    ExtPriceNormMA  = 5; // 0 = Close, 1 = Open, 2 = High, 3 = Low, 4 = HL/2, 5 = HLC/3, 6 = HLCC/4
extern int    ExtPriceSlowMA  = 5; // 0 = Close, 1 = Open, 2 = High, 3 = Low, 4 = HL/2, 5 = HLC/3, 6 = HLCC/4

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
//---- indicators
  SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,indicator_width1,indicator_color1);
  SetIndexBuffer(0,ExtMapBuffer1);
  SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,indicator_width2,indicator_color2);
  SetIndexBuffer(1,ExtMapBuffer2);
  SetIndexStyle(2,DRAW_HISTOGRAM,EMPTY,indicator_width3,indicator_color3);
  SetIndexBuffer(2,ExtMapBuffer3);
  return(0);
 }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
  int iLimit, i;
  double FastMA;
  double NormMA;
  double SlowMA;
  double SumBuff1,SumBuff2, SumBuff3;
  
  SumBuff1 = 0;
  SumBuff2 = 0;
  SumBuff3 = 0;
  
  int counted_bars=IndicatorCounted();
  if ( counted_bars > 0 ) counted_bars--;
  iLimit = Bars; //- counted_bars;
  for ( i = 0; i <= iLimit; i++ ) {
    ExtMapBuffer1[i]=0;
    ExtMapBuffer2[i]=0;
    ExtMapBuffer3[i]=0;
    FastMA = iMA( NULL, 0, ExtPeriodFastMA, 0, ExtModeFastMA, ExtPriceFastMA, i );
    NormMA = iMA( NULL, 0, ExtPeriodNormMA, 0, ExtModeNormMA, ExtPriceNormMA, i );
    SlowMA = iMA( NULL, 0, ExtPeriodSlowMA, 0, ExtModeSlowMA, ExtPriceSlowMA, i );
    if (FastMA > NormMA && NormMA > SlowMA) ExtMapBuffer1[i] = 1;
    else if (FastMA < NormMA && NormMA < SlowMA) ExtMapBuffer2[i] = 1;
    else ExtMapBuffer3[i] = 1;
  }
  for(i=0; i<BrasForAnalis; i++) {
    SumBuff1 = SumBuff1 + ExtMapBuffer1[i];
    SumBuff2 = SumBuff2 + ExtMapBuffer2[i];
    SumBuff3 = SumBuff3 + ExtMapBuffer3[i];
  }
  
  Comment("   = ",BrasForAnalis,"\n",
          " = ",SumBuff3," , ",NormalizeDouble(SumBuff3*100/BrasForAnalis,2),"%\n",
          " = ",SumBuff1+SumBuff2," , ",NormalizeDouble((SumBuff1+SumBuff2)*100/BrasForAnalis,2),"%\n", 
          "  = ",SumBuff1," , ",NormalizeDouble(SumBuff1*100/BrasForAnalis,2),"%\n", 
          "   = ",SumBuff2," , ",NormalizeDouble(SumBuff2*100/BrasForAnalis,2),"%\n"); 
    
return(0);
}
//+------------------------------------------------------------------+


